var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
if ("nsIFileSpec" in Components.interfaces)
  var FileSpec = Components.classes["@mozilla.org/filespec;1"].createInstance(Components.interfaces.nsIFileSpec);
var LocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var FileProtocolHandler = IOService.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
var nsIRDFResource = Components.interfaces.nsIRDFResource;
var nsIRDFLiteral = Components.interfaces.nsIRDFLiteral;

var datasource;
var NClength;

function OpenAccountFile() {
//Datei-ffnen Dialog erzeugen
  filePicker.init(window, strbundle.getString("OpenFile"), nsIFilePicker.modeOpen);
  filePicker.appendFilter(strbundle.getString("AccountFile") + " (*.rdf)","*.rdf;");  

  if(filePicker.show() == nsIFilePicker.returnOK) {
    datasource = RDFService.GetDataSourceBlocking(FileProtocolHandler.getURLSpecFromFile(filePicker.file));
    NClength = NC.length;
    
    ReadGlobalData();
  }
}

function ReadGlobalData() {
/*****************************************************************************************************
* allgemeine einstellungen in objGlobal speichern
******************************************************************************************************/
  objGlobal = new Object;

  var rdfGlobal = RDFService.GetResource("http://accountex/global");
  var arcs = datasource.ArcLabelsOut(rdfGlobal);

	if (!arcs.hasMoreElements()) {
	  alert(strbundle.getString("0002"));
	} else {

    while (arcs.hasMoreElements()) {
      var arc = arcs.getNext().QueryInterface(nsIRDFResource);
      var arcName = arc.Value;
      arcName = arcName.substring(NClength, arcName.length);
      objGlobal[arcName] = datasource.GetTarget(rdfGlobal, arc, true).QueryInterface(nsIRDFLiteral).Value;
    }
  }
  
//  if (objGlobal.type == "pop3" || objGlobal.type == "imap" || objGlobal.type == "none") {
    ReadServerData();
//  } else {
//    alert(strbundle.getString("0006"));
//  }
}

function ReadServerData() {
/*****************************************************************************************************
* server daten in objServer speichern
******************************************************************************************************/
  objServer = new Object;
      
  var rdfServer = RDFService.GetResource("http://accountex/server");
  var arcs = datasource.ArcLabelsOut(rdfServer);

  while (arcs.hasMoreElements()) {
    var arc = arcs.getNext().QueryInterface(nsIRDFResource);
    var arcName = arc.Value;
    arcName = arcName.substring(NClength, arcName.length);
    objServer[arcName] = datasource.GetTarget(rdfServer, arc, true).QueryInterface(nsIRDFLiteral).Value;
  } 

  CheckServerData();
}

function ReadImapData() {
/*****************************************************************************************************
* imap daten in objImap speichern
******************************************************************************************************/
  objImap = new Object;
      
  var rdfImap = RDFService.GetResource("http://accountex/imap");
  var arcs = datasource.ArcLabelsOut(rdfImap);

  while (arcs.hasMoreElements()) {
    var arc = arcs.getNext().QueryInterface(nsIRDFResource);
    var arcName = arc.Value;
    arcName = arcName.substring(NClength, arcName.length);
    objImap[arcName] = datasource.GetTarget(rdfImap, arc, true).QueryInterface(nsIRDFLiteral).Value;
  }  
}

function ReadPopData() {
/*****************************************************************************************************
* pop3 daten in objPop3 speichern
******************************************************************************************************/
  objPop3 = new Object;
      
  var rdfPop3 = RDFService.GetResource("http://accountex/pop3");
  var arcs = datasource.ArcLabelsOut(rdfPop3);

  while (arcs.hasMoreElements()) {
    var arc = arcs.getNext().QueryInterface(nsIRDFResource);
    var arcName = arc.Value;
    arcName = arcName.substring(NClength, arcName.length);
    objPop3[arcName] = datasource.GetTarget(rdfPop3, arc, true).QueryInterface(nsIRDFLiteral).Value;
  } 
}

function AccountImport() {
  switch (objGlobal.type) {
  case "imap":
    ReadImapData();

    /*****************************************************************************************************
    * prfen ob der Account schon existiert
    ******************************************************************************************************/
    if (AccountExists(objServer.username,objServer.hostName,objGlobal.type)) {
      alert(strbundle.getString("0004"));
      break;
    }

    /*****************************************************************************************************
    * prfen ob ein Lokaler Ordner bereits vorhanden ist
    ******************************************************************************************************/
    CheckLocalFolder();

    var server = accountManager.createIncomingServer(objServer.username,objServer.hostName,objGlobal.type);
    var imap = server.QueryInterface(Components.interfaces.nsIImapIncomingServer);
    var identity = accountManager.createIdentity();

    imap.capabilityPref = objImap.capabilityPref;
    imap.personalNamespace = objImap.personalNamespace;
    imap.publicNamespace = objImap.publicNamespace;
    imap.otherUsersNamespace = objImap.otherUsersNamespace;
    imap.downloadBodiesOnGetNewMail = Number(objImap.downloadBodiesOnGetNewMail);
    imap.maximumConnectionsNumber = objImap.maximumConnectionsNumber;
    imap.timeOutLimits = objImap.timeOutLimits;
    imap.doingLsub = Number(objImap.doingLsub);
    imap.storeReadMailInPFC = Number(objImap.storeReadMailInPFC);
    imap.overrideNamespaces = Number(objImap.overrideNamespaces);
    imap.fetchByChunks = Number(objImap.fetchByChunks);
    imap.mimePartsOnDemand = Number(objImap.mimePartsOnDemand);
    imap.isAOLServer = Number(objImap.isAOLServer);
    imap.usingSubscription = Number(objImap.usingSubscription);
    imap.cleanupInboxOnExit = Number(objImap.cleanupInboxOnExit);
    imap.storeSentMailInPFC = Number(objImap.storeSentMailInPFC);
    imap.offlineDownload = Number(objImap.offlineDownload);
    imap.dualUseFolders = Number(objImap.dualUseFolders);
    imap.aOLMailboxView = Number(objImap.aOLMailboxView);
    imap.serverDirectory = objImap.serverDirectory;
    imap.adminUrl = objImap.adminUrl;
    imap.manageMailAccountUrl = objImap.manageMailAccountUrl;
    imap.deleteModel = objImap.deleteModel;
    imap.emptyTrashThreshhold = objImap.emptyTrashThreshhold;
    imap.redirectorType = objImap.redirectorType;
    imap.timeOutLimits = objImap.timeOutLimits;

    server.port = objServer.port;
    server.isSecure = Number(objServer.isSecure);
    server.useSecAuth = Number(objServer.useSecAuth);
    server.loginAtStartUp = Number(objServer.loginAtStartUp);
    server.biffMinutes = objServer.biffMinutes;
    server.downloadOnBiff = Number(objServer.downloadOnBiff);
    server.emptyTrashOnExit = Number(objServer.emptyTrashOnExit);      

    if (server.localPath instanceof Components.interfaces.nsILocalFile) {
      LocalFile.initWithPath(objServer.localPath);
      server.localPath = LocalFile;
    }
    else {
      FileSpec.unicodePath = objServer.localPath;
      server.localPath = FileSpec;
    }
    server.prettyName = objServer.prettyName;

    var account = accountManager.createAccount();
    
    for (var i = 0; i < objGlobal.identities; i++) {
      var identity = accountManager.createIdentity();

      objIdentity = new Object;
             
      var rdfIdentity = RDFService.GetResource("http://accountex/identity" + i);
      var arcs = datasource.ArcLabelsOut(rdfIdentity);
       
      while (arcs.hasMoreElements()) {
        var arc = arcs.getNext().QueryInterface(nsIRDFResource);
        var arcName = arc.Value;
        arcName = arcName.substring(NClength, arcName.length);
        objIdentity[arcName] = datasource.GetTarget(rdfIdentity, arc, true).QueryInterface(nsIRDFLiteral).Value;
        identity[arcName] = objIdentity[arcName];
      }                
      account.addIdentity(identity);
    }

    server.valid = false;
    account.incomingServer = server;
    server.valid = true;

    AccountImportFinish();

    break;

  case "none":
    /*****************************************************************************************************
    * prfen ob ein Lokaler Ordner bereits vorhabden ist
    ******************************************************************************************************/
    CheckLocalFolder();

    var localServer = null;
    try {
      localServer = accountManager.localFoldersServer;
    }
    catch (ex) {
      localServer = null;
    }

    if (localServer == null) {
      var server = accountManager.createIncomingServer("nobody","Local Folders","none");
    } else {
      var server = accountManager.localFoldersServer
    }

    if (server.localPath instanceof Components.interfaces.nsILocalFile) {
      LocalFile.initWithPath(objServer.localPath);
      server.localPath = LocalFile;
    }
    else {
      FileSpec.unicodePath = objServer.localPath;
      server.localPath = FileSpec;
    }

    server.emptyTrashOnExit = objServer.emptyTrashOnExit;

    server.prettyName = objServer.prettyName;

    /*****************************************************************************************************
    * Lokalen Account erstellen
    ******************************************************************************************************/      
    var account = accountManager.createAccount();
    account.incomingServer = server;

    AccountImportFinish();

    break;

  case "pop3":
    ReadPopData();

    /*****************************************************************************************************
    * prfen ob der Account schon existiert
    ******************************************************************************************************/
    if (AccountExists(objServer.username,objServer.hostName,objGlobal.type)) {
      alert(strbundle.getString("0004"));
      break;
    }

    /*****************************************************************************************************
    * prfen wo deferredToAccount hingeht
    ******************************************************************************************************/

    if (objPop3.deferredToAccount == 1) {
      if (AccountNameExists(objPop3.deferredToAccountName) == false) {
        var result = promptService.confirmEx(window,strbundle.getString("TitleImport"), strbundle.getString("0005"), promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 + promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1 + promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2, strbundle.getString("Wizard01"), null, strbundle.getString("Wizard02"), null, {value:0});
        switch (result) {
        case 0:
          //Separater Posteingang
          var tmpDefferedAccount = "";
          break;
        case 1:
          //Abbruch
          break;
        case 2:
          //Lokaler Ordner
          if (CheckLocalFolder()) {
            var localFoldersServer = accountManager.localFoldersServer;
            var localFoldersAccount = accountManager.FindAccountForServer(localFoldersServer);
            var tmpDefferedAccount = localFoldersAccount.key;
            break;
          }
        }
      } else {
        var tmpDefferedAccount = GetNameAccount(objPop3.deferredToAccountName); 
      }
    }

    /*****************************************************************************************************
    * prfen ob ein Lokaler Ordner bereits vorhabden ist
    ******************************************************************************************************/
    CheckLocalFolder();
 
    var server = accountManager.createIncomingServer(objServer.username,objServer.hostName,objGlobal.type);
    var pop3 = server.QueryInterface(Components.interfaces.nsIPop3IncomingServer);
    var identity = accountManager.createIdentity();
    
    pop3.deferredToAccount = tmpDefferedAccount;
 
    pop3.headersOnly = Number(objPop3.headersOnly);
    pop3.leaveMessagesOnServer = Number(objPop3.leaveMessagesOnServer);
    pop3.deleteByAgeFromServer = Number(objPop3.deleteByAgeFromServer);
    pop3.numDaysToLeaveOnServer = objPop3.numDaysToLeaveOnServer;
    pop3.deleteMailLeftOnServer = Number(objPop3.deleteMailLeftOnServer);
    pop3.deferGetNewMail = Number(objPop3.deferGetNewMail);

    server.port = objServer.port;
    server.isSecure = Number(objServer.isSecure);
    server.useSecAuth = Number(objServer.useSecAuth);
    server.loginAtStartUp = Number(objServer.loginAtStartUp);
    server.biffMinutes = objServer.biffMinutes;
    server.downloadOnBiff = Number(objServer.downloadOnBiff);
    server.emptyTrashOnExit = Number(objServer.emptyTrashOnExit);      
    if (server.localPath instanceof Components.interfaces.nsILocalFile) {
      LocalFile.initWithPath(objServer.localPath);
      server.localPath = LocalFile;
    }
    else {
      FileSpec.unicodePath = objServer.localPath;
      server.localPath = FileSpec;
    }
    server.prettyName = objServer.prettyName;

    var account = accountManager.createAccount();
      for (var i = 0; i < objGlobal.identities; i++) {
        var identity = accountManager.createIdentity();

        objIdentity = new Object;
              
        var rdfIdentity = RDFService.GetResource("http://accountex/identity" + i);
        var arcs = datasource.ArcLabelsOut(rdfIdentity);
        
        while (arcs.hasMoreElements()) {
          var arc = arcs.getNext().QueryInterface(nsIRDFResource);
          var arcName = arc.Value;
          arcName = arcName.substring(NClength, arcName.length);
          objIdentity[arcName] = datasource.GetTarget(rdfIdentity, arc, true).QueryInterface(nsIRDFLiteral).Value;

          identity[arcName] = objIdentity[arcName];
        }                
                
        account.addIdentity(identity);

      }

      server.valid = false;
      account.incomingServer = server;
      server.valid = true;
            
      AccountImportFinish();

      break;
  }
}

function CheckServerData() {
  //Prfen ob der angegebene Pfad existiert

  LocalFile.initWithPath(objServer.localPath);
  if (!LocalFile.exists()) {
    ServerPath.value = objServer.localPath
    deck.setAttribute("selectedIndex", "3");
    forwardButton.setAttribute("disabled", true);
  } else {
    AccountImport();
  }  
}


function AccountImportFinish() {
/*****************************************************************************************************
* Dialog abschlieen
******************************************************************************************************/
  deck.setAttribute("selectedIndex", "4");
  var finishFile = document.getElementById("finishFile");
  finishFile.value = filePicker.file.path;
  backButton.setAttribute("disabled", true); 
  forwardButton.label = forwardButton.getAttribute("finishedval");
  forwardButton.setAttribute("dlgtype", "finish");
  cancelButton.setAttribute("disabled", true);  
  checkImportFinish = document.getElementById("checkExportFinish");
  checkImportFinish.checked = false;
}

function AccountNameExists(AccountName) {
/*****************************************************************************************************
* Prfen ob der per Name bergebene Account existiert
******************************************************************************************************/
  var defferedAccountExists = false;
  
  var originalAccounts = PrefValue("mail.accountmanager.accounts");
  if (originalAccounts) {
    var accounts = originalAccounts.split(",");
    var accountCount = accounts.length;
      for (var i = 0; i < accountCount; i++) {
        var accountTMP = accountManager.getAccount(accounts[i]);
        var serverTMP = accountTMP.incomingServer;
        if (serverTMP.prettyName == AccountName)
        {
           defferedAccountExists = true;
           break;
        }
      }
  }
  return defferedAccountExists;
}

function GetNameAccount(AccountName) {
/*****************************************************************************************************
* Account.key anhand des PrettyName herausfinden
******************************************************************************************************/
  var getNameAccount = "";
  
  var originalAccounts = PrefValue("mail.accountmanager.accounts");
  if (originalAccounts) {
    var accounts = originalAccounts.split(",");
    var accountCount = accounts.length;
      for (var i = 0; i < accountCount; i++) {
        var accountTMP = accountManager.getAccount(accounts[i]);
        var serverTMP = accountTMP.incomingServer;
        if (serverTMP.prettyName == AccountName)
        {
           getNameAccount = accountTMP.key;
           break;
        }
      }
  }
  return getNameAccount;
}

function CheckLocalFolder(){
 /*****************************************************************************************************
* prfen ob ein Lokaler Ordner bereits vorhabden ist
******************************************************************************************************/
  var localFoldersServer = false;

  try {
    localFoldersServer = accountManager.localFoldersServer;
  }
  catch (ex) {
    localFoldersServer = false;
  }
  if (objGlobal.type == "none") {
    if (localFoldersServer != false) {

      var result = promptService.confirmEx(window, strbundle.getString("TitleImport"), strbundle.getString("0001"), (promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_0)+(promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_1),strbundle.getString("WizardContinue"),strbundle.getString("WizardExit"), null, null, {value:0});
      if (result == 1) {
      }  
    }
  } else {
    if (localFoldersServer == false) {
      var result = promptService.confirmEx(window, strbundle.getString("TitleImport"), strbundle.getString("0003"), (promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_0)+(promptService.BUTTON_TITLE_IS_STRING*promptService.BUTTON_POS_1),strbundle.getString("WizardContinue"),strbundle.getString("WizardExit"), null, null, {value:0});
      if (result == 1) {
        localFoldersServer = false;
      } else {
        // Lokalen Ordner erstellen
        if ("@mozilla.org/messenger/migrator;1" in Components.classes)
          messengerMigrator = Components.classes["@mozilla.org/messenger/migrator;1"].getService(Components.interfaces.nsIMessengerMigrator);
        else
          messengerMigrator = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
        messengerMigrator.createLocalMailAccount(false /* false, since we are not migrating */);
        localFoldersServer = true;
      }
    }
  } 

  return localFoldersServer;
}